local LrApplication = import "LrApplication"
local LrView = import "LrView"
local LrBinding = import "LrBinding"
local LrPrefs = import "LrPrefs"
local LrDialogs = import "LrDialogs"
local LrTasks = import "LrTasks"
local LrFunctionContext = import "LrFunctionContext"
local LrLogger = import "LrLogger"
local log = LrLogger("MergeTitles")

local MergeTitles = require("MTFilter.lua")
require("UpdateCheck.lua")

local ExportFunc = function (context)
	local cat = LrApplication.activeCatalog()
	log:enable("logfile")

	local count = 0
	local changed = 0
	
	cat:withWriteAccessDo("Merge Titles", function()
		local prefs = LrPrefs.prefsForPlugin()

		for i,p in ipairs(cat.targetPhotos) do
			if MergeTitles.DoPhotoMerge(p, prefs) then
				changed = changed + 1
				
				if UpdateCheck.StringLookup(prefs) < 1 and changed >= 3 then
					break
				end

			end
			count = count + 1
		end
	end	)

	LrDialogs.message("Processed " .. count .. " picture" .. (count == 1 and "" or "s") .. ".",
						changed .. " picture" .. (changed == 1 and "" or "s") .. " changed.")
end

LrTasks.startAsyncTask( function () LrFunctionContext.callWithContext("Merge Titles", ExportFunc ) end , "Find Duplicate Refs" )
